Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_random_numbers.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_random_numbers.F90	(revision 4489)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_random_numbers.F90	(revision 4489)
@@ -0,0 +1,304 @@
+! radiation_random_numbers.F90 - Generate random numbers for McICA solver
+!
+! (C) Copyright 2020- ECMWF.
+!
+! This software is licensed under the terms of the Apache Licence Version 2.0
+! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+!
+! In applying this licence, ECMWF does not waive the privileges and immunities
+! granted to it by virtue of its status as an intergovernmental organisation
+! nor does it submit to any jurisdiction.
+!
+! Author:  Robin Hogan
+! Email:   r.j.hogan@ecmwf.int
+!
+! The derived type "rng_type" is a random number generator that uses
+! either (1) Fortran's built-in random_number function, or (2) a
+! vectorized version of the MINSTD linear congruential generator.  In
+! the case of (2), an rng_type object is initialized with a seed that
+! is used to fill up a state of "nmaxstreams" elements using the C++
+! minstd_rand0 version of the MINSTD linear congruential generator
+! (LNG), which has the form istate[i+1] = mod(istate[i]*A0, M) from
+! i=1 to i=nmaxstreams. Subsequent requests for blocks of nmaxstreams
+! of random numbers use the C++ minstd_ran algorithm in a vectorizable
+! form, which modifies the state elements via istate[i] <-
+! mod(istate[i]*A, M). Uniform deviates are returned that normalize
+! the state elements to the range 0-1.
+!
+! The MINSTD generator was coded because the random_numbers_mix
+! generator in the IFS was found not to vectorize well on some
+! hardware.  I am no expert on random number generators, so my
+! implementation should really be looked at and improved by someone
+! who knows what they are doing.
+!
+! Reference for MINSTD: Park, Stephen K.; Miller, Keith
+! W. (1988). "Random Number Generators: Good Ones Are Hard To Find"
+! (PDF). Communications of the ACM. 31 (10):
+! 1192–1201. doi:10.1145/63039.63042
+!
+! Modifications
+!   2022-12-01  R. Hogan  Fixed zeroed state in single precision
+
+module radiation_random_numbers
+
+  use parkind1, only : jprb, jprd, jpim, jpib
+
+  implicit none
+
+  public :: rng_type, IRngMinstdVector, IRngNative
+
+  enum, bind(c) 
+    enumerator IRngNative, &    ! Built-in Fortran-90 RNG
+         &     IRngMinstdVector ! Vector MINSTD algorithm
+  end enum
+  
+  ! Maximum number of random numbers that can be computed in one call
+  ! - this can be increased
+  integer(kind=jpim), parameter :: NMaxStreams = 512
+  
+  ! A requirement of the generator is that the operation mod(A*X,M) is
+  ! performed with no loss of precision, so type used for A and X must
+  ! be able to hold the largest possible value of A*X without
+  ! overflowing, going negative or losing precision. The largest
+  ! possible value is 48271*2147483647 = 103661183124337. This number
+  ! can be held in either a double-precision real number, or an 8-byte
+  ! integer. Either may be used, but on some hardwares it has been
+  ! found that operations on double-precision reals are faster. Select
+  ! which you prefer by defining USE_REAL_RNG_STATE for double
+  ! precision, or undefining it for an 8-byte integer.
+#define USE_REAL_RNG_STATE 1
+
+  ! Define RNG_STATE_TYPE based on USE_REAL_RNG_STATE, where jprd
+  ! refers to a double-precision number regardless of the working
+  ! precision described by jprb, while jpib describes an 8-byte
+  ! integer
+#ifdef USE_REAL_RNG_STATE
+#define RNG_STATE_TYPE real(kind=jprd)
+#else
+#define RNG_STATE_TYPE integer(kind=jpib)
+#endif
+
+  ! The constants used in the main random number generator
+  RNG_STATE_TYPE , parameter :: IMinstdA  = 48271
+  RNG_STATE_TYPE , parameter :: IMinstdM  = 2147483647
+
+  ! An alternative value of A that can be used to initialize the
+  ! members of the state from a single seed
+  RNG_STATE_TYPE , parameter :: IMinstdA0 = 16807
+  
+  ! Scaling to convert the state to a uniform deviate in the range 0
+  ! to 1 in working precision
+  real(kind=jprb), parameter :: IMinstdScale = 1.0_jprb / real(IMinstdM,jprb)
+
+  !---------------------------------------------------------------------
+  ! A random number generator type: after being initialized with a
+  ! seed, type and optionally a number of vector streams, subsequent
+  ! calls to "uniform_distribution" are used to fill 1D or 2D arrays
+  ! with random numbers in a way that ought to be fast.
+  type rng_type
+
+    integer(kind=jpim) :: itype = IRngNative
+    RNG_STATE_TYPE     :: istate(NMaxStreams)
+    integer(kind=jpim) :: nmaxstreams = NMaxStreams
+    integer(kind=jpim) :: iseed
+
+  contains
+    procedure :: initialize
+    procedure :: uniform_distribution_1d, &
+         &       uniform_distribution_2d, &
+         &       uniform_distribution_2d_masked
+    generic   :: uniform_distribution => uniform_distribution_1d, &
+         &                               uniform_distribution_2d, &
+         &                               uniform_distribution_2d_masked
+
+  end type rng_type
+
+contains
+
+  !---------------------------------------------------------------------
+  ! Initialize a random number generator, where "itype" may be either
+  ! IRngNative, indicating to use Fortran's native random_number
+  ! subroutine, or IRngMinstdVector, indicating to use the MINSTD
+  ! linear congruential generator (LCG).  In the latter case
+  ! "nmaxstreams" should be provided indicating that random numbers
+  ! will be requested in blocks of this length. The generator is
+  ! seeded with "iseed".
+  subroutine initialize(this, itype, iseed, nmaxstreams)
+
+    class(rng_type), intent(inout) :: this
+    integer(kind=jpim), intent(in), optional :: itype
+    integer(kind=jpim), intent(in), optional :: iseed
+    integer(kind=jpim), intent(in), optional :: nmaxstreams
+
+    integer, allocatable :: iseednative(:)
+    integer :: nseed, jseed, jstr
+    real(jprd) :: rseed ! Note this must be in double precision
+
+    if (present(itype)) then
+      this%itype = itype
+    else
+      this%itype = IRngNative
+    end if
+    
+    if (present(iseed)) then
+      this%iseed = iseed
+    else
+      this%iseed = 1
+    end if
+
+    if (present(nmaxstreams)) then
+      this%nmaxstreams = nmaxstreams
+    else
+      this%nmaxstreams = NMaxStreams
+    end if
+    
+    if (this%itype == IRngMinstdVector) then
+      ! ! OPTION 1: Use the C++ minstd_rand0 algorithm to populate the
+      ! ! state: this loop is not vectorizable because the state in
+      ! ! one stream depends on the one in the previous stream.
+      ! this%istate(1) = this%iseed
+      ! do jseed = 2,this%nmaxstreams
+      !   this%istate(jseed) = mod(IMinstdA0 * this%istate(jseed-1), IMinstdM)
+      ! end do
+
+      ! OPTION 2: Use a modified (and vectorized) C++ minstd_rand0 algorithm to
+      ! populate the state
+      rseed = real(abs(this%iseed),jprd)
+      do jstr = 1,this%nmaxstreams
+        ! Note that nint returns an integer of type jpib (8-byte)
+        ! which may be converted to double if that is the type of
+        ! istate
+        this%istate(jstr) = nint(mod(rseed*jstr*(1.0_jprd-0.05_jprd*jstr &
+             &      +0.005_jprd*jstr**2)*IMinstdA0, real(IMinstdM,jprd)),kind=jpib)
+      end do
+
+      ! One warmup of the C++ minstd_rand algorithm
+      do jstr = 1,this%nmaxstreams
+        this%istate(jstr) = mod(IMinstdA * this%istate(jstr), IMinstdM)
+      end do
+      
+    else
+      ! Native generator by default
+      call random_seed(size=nseed)
+      allocate(iseednative(nseed))
+      do jseed = 1,nseed
+        iseednative(jseed) = this%iseed + jseed - 1
+      end do
+      call random_seed(put=iseednative)
+      deallocate(iseednative)
+    end if
+
+  end subroutine initialize
+
+  !---------------------------------------------------------------------
+  ! Populate vector "randnum" with pseudo-random numbers; if rannum is
+  ! of length greater than nmaxstreams (specified when the generator
+  ! was initialized) then only the first nmaxstreams elements will be
+  ! assigned.
+  subroutine uniform_distribution_1d(this, randnum)
+
+    class(rng_type), intent(inout) :: this
+    real(kind=jprb), intent(out)   :: randnum(:)
+
+    integer :: imax, i
+
+    if (this%itype == IRngMinstdVector) then
+      
+      imax = min(this%nmaxstreams, size(randnum))
+
+      ! C++ minstd_rand algorithm
+      do i = 1, imax
+        ! The following calculation is computed entirely with 8-byte
+        ! numbers (whether real or integer)
+        this%istate(i) = mod(IMinstdA * this%istate(i), IMinstdM)
+        ! Scale the current state to a number in working precision
+        ! (jprb) between 0 and 1
+        randnum(i) = IMinstdScale * this%istate(i)
+      end do
+
+    else
+
+      call random_number(randnum)
+
+    end if
+
+  end subroutine uniform_distribution_1d
+
+
+  !---------------------------------------------------------------------
+  ! Populate matrix "randnum" with pseudo-random numbers; if the inner
+  ! dimension of rannum is of length greater than nmaxstreams
+  ! (specified when the generator was initialized) then only the first
+  ! nmaxstreams elements along this dimension will be assigned.
+  subroutine uniform_distribution_2d(this, randnum)
+
+    class(rng_type), intent(inout) :: this
+    real(kind=jprb), intent(out)   :: randnum(:,:)
+
+    integer :: imax, jblock, i
+
+    if (this%itype == IRngMinstdVector) then
+      
+      imax = min(this%nmaxstreams, size(randnum,1))
+
+      ! C++ minstd_ran algorithm
+      do jblock = 1,size(randnum,2)
+        ! These lines should be vectorizable
+        do i = 1, imax
+          this%istate(i) = mod(IMinstdA * this%istate(i), IMinstdM)
+          randnum(i,jblock) = IMinstdScale * this%istate(i)
+        end do
+      end do
+
+    else
+
+      call random_number(randnum)
+
+    end if
+
+  end subroutine uniform_distribution_2d
+
+  !---------------------------------------------------------------------
+  ! Populate matrix "randnum" with pseudo-random numbers; if the inner
+  ! dimension of rannum is of length greater than nmaxstreams
+  ! (specified when the generator was initialized) then only the first
+  ! nmaxstreams elements along this dimension will be assigned. This
+  ! version only operates on outer dimensions for which "mask" is true.
+  subroutine uniform_distribution_2d_masked(this, randnum, mask)
+
+    class(rng_type), intent(inout) :: this
+    real(kind=jprb), intent(inout) :: randnum(:,:)
+    logical,         intent(in)    :: mask(:)
+
+    integer :: imax, jblock, i
+
+    if (this%itype == IRngMinstdVector) then
+      
+      imax = min(this%nmaxstreams, size(randnum,1))
+
+      ! C++ minstd_ran algorithm
+      do jblock = 1,size(randnum,2)
+        if (mask(jblock)) then
+          ! These lines should be vectorizable
+          do i = 1, imax
+            this%istate(i) = mod(IMinstdA * this%istate(i), IMinstdM)
+            randnum(i,jblock) = IMinstdScale * this%istate(i)
+          end do
+        end if
+      end do
+
+    else
+
+      do jblock = 1,size(randnum,2)
+        if (mask(jblock)) then
+          call random_number(randnum(:,jblock))
+        end if
+      end do
+
+    end if
+
+  end subroutine uniform_distribution_2d_masked
+
+
+end module radiation_random_numbers
+
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_save.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_save.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_save.F90	(revision 4489)
@@ -33,5 +33,6 @@
   ! thermodynamics object
   subroutine save_fluxes(file_name, config, thermodynamics, flux, &
-       &                 iverbose, is_hdf5_file, experiment_name)
+       &                 iverbose, is_hdf5_file, experiment_name, &
+       &                 is_double_precision)
 
     use yomhook,                  only : lhook, dr_hook
@@ -50,4 +51,5 @@
     integer,          optional, intent(in) :: iverbose
     logical,          optional, intent(in) :: is_hdf5_file
+    logical,          optional, intent(in) :: is_double_precision
     character(len=*), optional, intent(in) :: experiment_name
 
@@ -96,4 +98,9 @@
     ! output file column varies most slowly so need to transpose
     call out_file%transpose_matrices(.true.)
+
+    ! Set default precision for file, if specified
+    if (present(is_double_precision)) then
+      call out_file%double_precision(is_double_precision)
+    end if
 
     ! Spectral fluxes in memory are dimensioned (nband,ncol,nlev), but
@@ -885,5 +892,5 @@
            &   dim2_name="column", dim1_name="level", &
            &   units_str="m", long_name="Ice effective radius")
-      if (allocated(cloud%re_ice)) then
+      if (associated(cloud%re_ice)) then
         call out_file%define_variable("re_ice", &
              &   dim2_name="column", dim1_name="level", &
@@ -966,5 +973,5 @@
       call out_file%put("q_ice", cloud%q_ice)
       call out_file%put("re_liquid", cloud%re_liq)
-      if (allocated(cloud%re_ice)) then
+      if (associated(cloud%re_ice)) then
         call out_file%put("re_ice", cloud%re_ice)
       end if
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_scheme.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_scheme.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_scheme.F90	(revision 4489)
@@ -13,16 +13,15 @@
 SUBROUTINE RADIATION_SCHEME &
 ! Inputs
-     & (KIDIA, KFDIA, KLON, KLEV, KAEROLMDZ, NSW, &
+     & (KIDIA, KFDIA, KLON, KLEV, KAEROSOL, NSW, &
      &  IDAY, TIME, &
      &  PSOLAR_IRRADIANCE, &
-     &  PMU0, PTEMPERATURE_SKIN, PALBEDO_DIF, PALBEDO_DIR, &
+     &  PMU0, PTEMPERATURE_SKIN, &
+     &  PALBEDO_DIF, PALBEDO_DIR, &
      &  PEMIS, PEMIS_WINDOW, &
-     &  PCCN_LAND, PCCN_SEA, &
-     &  PGELAM, PGEMU, PLAND_SEA_MASK, &
-     &  PPRESSURE, PTEMPERATURE, &
+     &  PGELAM, PGEMU, &
      &  PPRESSURE_H, PTEMPERATURE_H, PQ, PQSAT, &
      &  PCO2, PCH4, PN2O, PNO2, PCFC11, PCFC12, PHCFC22, &
      &  PCCL4, PO3, PO2, &
-     &  PCLOUD_FRAC, PQ_LIQUID, PQ_ICE, PQ_RAIN, PQ_SNOW, &
+     &  PCLOUD_FRAC, PQ_LIQUID, PQ_ICE, PQ_SNOW, &
      &  ZRE_LIQUID_UM, ZRE_ICE_UM, &
      &  PAEROSOL_OLD, PAEROSOL, &
@@ -117,9 +116,10 @@
 INTEGER(KIND=JPIM),INTENT(IN) :: KLEV     ! Number of levels
 !INTEGER, INTENT(IN) :: KLON, KLEV
-INTEGER(KIND=JPIM),INTENT(IN) :: KAEROLMDZ ! Number of aerosol types
+!INTEGER(KIND=JPIM),INTENT(IN) :: KAEROLMDZ ! Number of aerosol types
+INTEGER(KIND=JPIM),INTENT(IN) :: KAEROSOL
 INTEGER(KIND=JPIM),INTENT(IN) :: NSW ! Numbe of bands
 
 ! AI ATTENTION
-INTEGER, PARAMETER :: KAEROSOL = 12
+!INTEGER, PARAMETER :: KAEROSOL = 12
 
 ! *** Single-level fields
@@ -139,9 +139,9 @@
 REAL(KIND=JPRB),   INTENT(IN) :: PGEMU(KLON)
 ! Land-sea mask
-REAL(KIND=JPRB),   INTENT(IN) :: PLAND_SEA_MASK(KLON) 
+!REAL(KIND=JPRB),   INTENT(IN) :: PLAND_SEA_MASK(KLON) 
 
 ! *** Variables on full levels
-REAL(KIND=JPRB),   INTENT(IN) :: PPRESSURE(KLON,KLEV)    ! (Pa)
-REAL(KIND=JPRB),   INTENT(IN) :: PTEMPERATURE(KLON,KLEV) ! (K)
+!REAL(KIND=JPRB),   INTENT(IN) :: PPRESSURE(KLON,KLEV)    ! (Pa)
+!REAL(KIND=JPRB),   INTENT(IN) :: PTEMPERATURE(KLON,KLEV) ! (K)
 ! *** Variables on half levels
 REAL(KIND=JPRB),   INTENT(IN) :: PPRESSURE_H(KLON,KLEV+1)    ! (Pa)
@@ -167,5 +167,5 @@
 REAL(KIND=JPRB),   INTENT(IN) :: PQ_LIQUID(KLON,KLEV)
 REAL(KIND=JPRB),   INTENT(IN) :: PQ_ICE(KLON,KLEV)
-REAL(KIND=JPRB),   INTENT(IN) :: PQ_RAIN(KLON,KLEV)
+!REAL(KIND=JPRB),   INTENT(IN) :: PQ_RAIN(KLON,KLEV)
 REAL(KIND=JPRB),   INTENT(IN) :: PQ_SNOW(KLON,KLEV)
 
@@ -174,6 +174,6 @@
 REAL(KIND=JPRB),   INTENT(IN) :: PAEROSOL(KLON,KLEV,KAEROSOL)
 
-REAL(KIND=JPRB),   INTENT(IN) :: PCCN_LAND(KLON) 
-REAL(KIND=JPRB),   INTENT(IN) :: PCCN_SEA(KLON) 
+!REAL(KIND=JPRB),   INTENT(IN) :: PCCN_LAND(KLON) 
+!REAL(KIND=JPRB),   INTENT(IN) :: PCCN_SEA(KLON) 
 
 !AI mars 2021
@@ -313,6 +313,6 @@
 if (lprint_input) then
   print*,'********** Verification des entrees *************'
-  print*,'KIDIA, KFDIA, KLON, KLEV, KAEROLMDZ, NSW =', &
-        KIDIA, KFDIA, KLON, KLEV, KAEROLMDZ, NSW
+  print*,'KIDIA, KFDIA, KLON, KLEV, KAEROSOL, NSW =', &
+        KIDIA, KFDIA, KLON, KLEV, KAEROSOL, NSW
   print*,'IDAY, TIME =', IDAY, TIME
   print*,'PSOLAR_IRRADIANCE =', PSOLAR_IRRADIANCE
@@ -320,8 +320,5 @@
   print*,'PTEMPERATURE_SKIN =',PTEMPERATURE_SKIN
   print*,'PEMIS, PEMIS_WINDOW =', PEMIS, PEMIS_WINDOW
-  print*,'PCCN_LAND, PCCN_SEA =', PCCN_LAND, PCCN_SEA
   print*,'PGELAM, PGEMU =', PGELAM, PGEMU
-  print*,'PPRESSURE =', PPRESSURE
-  print*,'PTEMPERATURE =', PTEMPERATURE
   print*,'PPRESSURE_H =', PPRESSURE_H
   print*,'PTEMPERATURE_H =', PTEMPERATURE_H
@@ -331,6 +328,6 @@
         PCO2, PCH4, PN2O, PNO2, PCFC11, PCFC12, PHCFC22, PCCL4
   print*,'PO3 =',PO3
-  print*,'PCLOUD_FRAC, PQ_LIQUID, PQ_ICE, PQ_RAIN, PQ_SNOW =', &
-        PCLOUD_FRAC, PQ_LIQUID, PQ_ICE, PQ_RAIN, PQ_SNOW
+  print*,'PCLOUD_FRAC, PQ_LIQUID, PQ_ICE, PQ_SNOW =', &
+        PCLOUD_FRAC, PQ_LIQUID, PQ_ICE, PQ_SNOW
   print*,'ZRE_LIQUID_UM, ZRE_ICE_UM =', &
         ZRE_LIQUID_UM, ZRE_ICE_UM
@@ -407,9 +404,10 @@
 ! Alternative approximate version using temperature and pressure from
 ! the thermodynamics structure
-CALL thermodynamics%calc_saturation_wrt_liquid(KIDIA, KFDIA)
+!CALL thermodynamics%calc_saturation_wrt_liquid(KIDIA, KFDIA)
+!AI ATTENTION
+thermodynamics%h2o_sat_liq = PQSAT
 
 print*,'********** SINGLE LEVEL VARS **********************************'
 !AI ATTENTION
-!thermodynamics%h2o_sat_liq = PQSAT
 ! Set single-level fileds
 single_level%solar_irradiance              = PSOLAR_IRRADIANCE
@@ -510,9 +508,9 @@
 
 print*,'******** AEROSOLS (allocate + input) **************************************'
-IF (NAERMACC > 0) THEN
+!IF (NAERMACC > 0) THEN
   CALL aerosol%allocate(KLON, 1, KLEV, KAEROSOL) ! MACC climatology
-ELSE
-  CALL aerosol%allocate(KLON, 1, KLEV, 6) ! Tegen climatology
-ENDIF
+!ELSE
+!  CALL aerosol%allocate(KLON, 1, KLEV, 6) ! Tegen climatology
+!ENDIF
 ! Compute the dry mass of each layer neglecting humidity effects, in
 ! kg m-2, needed to scale some of the aerosol inputs
@@ -644,4 +642,6 @@
 
 ! Compute UV fluxes as weighted sum of appropriate shortwave bands
+!AI ATTENTION
+if (0.eq.1) then
 PFLUX_UV       (KIDIA:KFDIA) = 0.0_JPRB
 DO JBAND = 1,NWEIGHT_UV
@@ -660,5 +660,5 @@
        &  * flux%sw_dn_surf_clear_band(IBAND_PAR(JBAND),KIDIA:KFDIA)
 ENDDO
-
+endif
 ! Compute effective broadband emissivity
 ZBLACK_BODY_NET_LW = flux%lw_dn(KIDIA:KFDIA,KLEV+1) &
@@ -679,4 +679,5 @@
 !AI ATTENTION
 !IF (YRERAD%LAPPROXSWUPDATE) THEN
+if (0.eq.1) then
 IF (rad_config%do_surface_sw_spectral_flux) THEN
   PSWDIFFUSEBAND(KIDIA:KFDIA,:) = 0.0_JPRB
@@ -693,5 +694,5 @@
   ENDDO
 ENDIF
-
+endif
 CALL single_level%deallocate
 CALL thermodynamics%deallocate
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_setup.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_setup.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_setup.F90	(revision 4489)
@@ -69,5 +69,5 @@
 CONTAINS
 
-  ! This routine copies information between the IFS radiation
+  ! This routine copies information between the LMDZ radiation
   ! configuration (stored in global variables) and the radiation
   ! configuration of the modular radiation scheme (stored in
@@ -75,16 +75,20 @@
   ! to print lots of information during the setup stage (default is
   ! no).
+! AI At the end of the routine, the parameters are read in namelist
+!    
   SUBROUTINE SETUP_RADIATION_SCHEME(LOUTPUT)
 
     USE YOMHOOK,  ONLY : LHOOK, DR_HOOK
+! AI (propre a IFS)    
 !    USE YOMLUN,   ONLY : NULNAM, NULOUT, NULERR
     USE YOMLUN,   ONLY : NULOUT, NULERR
     USE YOESRTWN, ONLY : NMPSRTM
-! AI ATTENTION
+! AI ATTENTION (propre a IFS)
 !    USE YOERAD,   ONLY : YRERAD
 
     USE radiation_interface,      ONLY : setup_radiation
-    USE radiation_aerosol_optics, ONLY : dry_aerosol_sw_mass_extinction
-
+!    USE radiation_aerosol_optics, ONLY : dry_aerosol_sw_mass_extinction
+
+! AI (propre a IFS)    
 !#include "posname.intfb.h"
 
@@ -143,4 +147,5 @@
     ! Do we do Hogan and Bozzo (2014) approximate longwave updates?
 ! AI ATTENTION (ifs : )
+     ! AI (propre a IFS)
 !    rad_config%do_lw_derivatives = YRERAD%LAPPROXLWUPDATE
     rad_config%do_lw_derivatives = .false.
@@ -161,6 +166,5 @@
     ! *** SETUP GAS OPTICS ***
 
-    ! Assume IFS has already set-up RRTM, so the setup_radiation
-    ! routine below does not have to (ifs : F)
+! routine below does not have to (ifs : F)
     print*,'i_gas_model =',rad_config%i_gas_model
     rad_config%do_setup_ifsrrtm = .TRUE.
@@ -174,7 +178,4 @@
 ! AI ATTENTION
 ! Choix offline : liquid_model_name = "SOCRATES"
-!    IF (YRERAD%NLIQOPT == 2) THEN
-!      rad_config%i_liq_model = ILiquidModelSlingo
-!    ELSEIF (YRERAD%NLIQOPT == 3) THEN
       rad_config%i_liq_model = ILiquidModelSOCRATES
       if (lprint_setp) then
@@ -182,25 +183,12 @@
       endif
 
-!    ELSE
-!      WRITE(NULERR,'(a,i0)') 'Unavailable liquid optics model in modular radiation scheme: NLIQOPT=', &
-!           &  YRERAD%NLIQOPT
-!      CALL ABOR1('RADIATION_SETUP: error interpreting NLIQOPT')   
-!    ENDIF
-
     ! Setup ice optics
 ! Choix offline : ice_model_name    = "Fu-IFS"
-!    IF (YRERAD%NICEOPT == 3) THEN
       rad_config%i_ice_model = IIceModelFu
       if (lprint_setp) then
         print*,'rad_config%i_ice_model =', rad_config%i_ice_model
       endif
-!    ELSEIF (YRERAD%NICEOPT == 4) THEN
-!      rad_config%i_ice_model = IIceModelBaran
-!    ELSE
-!      WRITE(NULERR,'(a,i0)') 'Unavailable ice optics model in modular radiation scheme: NICEOPT=', &
-!           &  YRERAD%NICEOPT
-!      CALL ABOR1('RADIATION_SETUP: error interpreting NICEOPT')   
-!    ENDIF
-
+
+! AI (propre a IFS)      
     ! For consistency with earlier versions of the IFS radiation
     ! scheme, we perform shortwave delta-Eddington scaling *after* the
@@ -215,4 +203,5 @@
     endif
 
+! AI (propre a IFS)    
     ! Use Exponential-Exponential cloud overlap to match original IFS
     ! implementation of Raisanen cloud generator
@@ -230,64 +219,4 @@
     endif
 
-!    IF (YRERAD%NAERMACC > 0) THEN
-      ! Using MACC climatology - in this case the aerosol optics file
-      ! will be chosen automatically
-
-      ! 12 IFS aerosol classes: 1-3 Sea salt, 4-6 Boucher desert dust,
-      ! 7 hydrophilic organics, 8 hydrophobic organics, 9&10
-      ! hydrophobic black carbon, 11 ammonium sulphate, 12 inactive
-      ! SO2
-      rad_config%n_aerosol_types = 12
-      if (lprint_setp) then
-        print*,'rad_config%n_aerosol_types =', rad_config%n_aerosol_types
-      endif
-
-      ! Indices to the aerosol optical properties in
-      ! aerosol_ifs_rrtm_*.nc, for each class, where negative numbers
-      ! index hydrophilic aerosol types and positive numbers index
-      ! hydrophobic aerosol types
-      rad_config%i_aerosol_type_map = 0 ! There can be up to 256 types
-!      if (lprint_setp) then
-!        print*,'rad_config%i_aerosol_type_map =', rad_config%i_aerosol_type_map
-!      endif
-
-      rad_config%i_aerosol_type_map(1:12) = (/ &
-           &  -1, &  ! Sea salt, size bin 1 (OPAC)
-           &  -2, &  ! Sea salt, size bin 2 (OPAC)
-           &  -3, &  ! Sea salt, size bin 3 (OPAC)
-           &   7, &  ! Desert dust, size bin 1 (Woodward 2001)
-           &   8, &  ! Desert dust, size bin 2 (Woodward 2001)
-           &   9, &  ! Desert dust, size bin 3 (Woodward 2001)
-           &  -4, &  ! Hydrophilic organic matter (OPAC)
-           &  10, &  ! Hydrophobic organic matter (OPAC)
-           &  11, &  ! Black carbon (Boucher)
-           &  11, &  ! Black carbon (Boucher)
-           &  -5, &  ! Ammonium sulphate (OPAC)
-           &  14 /)  ! Stratospheric sulphate (hand edited from OPAC)
-!     if (lprint_setp) then
-!       print*,'rad_config%i_aerosol_type_map =', rad_config%i_aerosol_type_map
-!     endif
-
-      ! Background aerosol mass-extinction coefficients are obtained
-      ! after the configuration files have been read - see later in
-      ! this routine.
-
-!    ELSE
-      ! Using Tegen climatology
-!      rad_config%n_aerosol_types = 6
-!      rad_config%i_aerosol_type_map = 0 ! There can be up to 256 types
-!      rad_config%i_aerosol_type_map(1:6) = (/ &
-!           &  1, &  ! Continental background
-!           &  2, &  ! Maritime
-!           &  3, &  ! Desert
-!           &  4, &  ! Urban
- !          &  5, &  ! Volcanic active
-!           &  6 /)  ! Stratospheric background
-
-      ! Manually set the aerosol optics file name (the directory will
-      ! be added automatically)
-!      rad_config%aerosol_optics_override_file_name = 'aerosol_ifs_rrtm_tegen.nc'
-!    ENDIF
-
 ! *** SETUP SOLVER ***
 
@@ -300,8 +229,4 @@
     ! Select longwave solver
 ! AI ATTENTION
-!    SELECT CASE (YRERAD%NLWSOLVER)
-!    CASE(0)
-!      rad_config%i_solver_lw = ISolverMcICA
-!    CASE(1)
       rad_config%i_solver_lw = ISolverSpartacus
       if (lprint_setp) then
@@ -309,36 +234,8 @@
       endif
 
-!    CASE(2)
-!      rad_config%i_solver_lw = ISolverSpartacus
-!      rad_config%do_3d_effects = .TRUE.
-!    CASE DEFAULT
-!      WRITE(NULERR,'(a,i0)') 'Unknown value for NLWSOLVER: ', YRERAD%NLWSOLVER
-!      CALL ABOR1('RADIATION_SETUP: error interpreting NLWSOLVER')
-!    END SELECT
-
-    ! Select shortwave solver
-!    SELECT CASE (YRERAD%NSWSOLVER)
-!    CASE(0)
-!      rad_config%i_solver_sw = ISolverMcICA
-!    CASE(1)
       rad_config%i_solver_sw = ISolverSpartacus
       if (lprint_setp) then
         print*,'rad_config%i_solver_sw =', rad_config%i_solver_sw
       endif
-
-!      rad_config%do_3d_effects = .FALSE.
-!      IF (YRERAD%NLWSOLVER == 2) THEN
-!        CALL ABOR1('RADIATION_SETUP: cannot represent 3D effects in LW but not SW')
-!      ENDIF
-!    CASE(2)
-!      rad_config%i_solver_sw = ISolverSpartacus
-!      rad_config%do_3d_effects = .TRUE.
-!      IF (YRERAD%NLWSOLVER == 1) THEN
-!        CALL ABOR1('RADIATION_SETUP: cannot represent 3D effects in SW but not LW')
-!      ENDIF
-!    CASE DEFAULT
-!      WRITE(NULERR,'(a,i0)') 'Unknown value for NSWSOLVER: ', YRERAD%NSWSOLVER
-!      CALL ABOR1('RADIATION_SETUP: error interpreting NSWSOLVER')
-!    END SELECT
 
     ! SPARTACUS solver requires delta scaling to be done separately
@@ -357,17 +254,4 @@
            rad_config%do_lw_aerosol_scattering
     endif
-
-!    SELECT CASE (YRERAD%NLWSCATTERING)
-!    CASE(1)
-!      rad_config%do_lw_cloud_scattering = .TRUE.
-!    CASE(2)
-!      rad_config%do_lw_cloud_scattering = .TRUE.
-!      IF (YRERAD%NAERMACC > 0) THEN
-        ! Tegen climatology omits data required to do longwave
-        ! scattering by aerosols, so only turn this on with a more
-        ! recent scattering database
-!      ENDIF
-!    END SELECT
-
 
     ! *** IMPLEMENT SETTINGS ***
@@ -379,23 +263,8 @@
     ! variables in the NAERAD namelist available in the YRERAD
     ! structure.
-!    CALL POSNAME(NULNAM, 'RADIATION', ISTAT)
-!    SELECT CASE (ISTAT)
-!      CASE(0)
-!        CALL rad_config%read(unit=NULNAM)
-!      CASE(1)
-!        WRITE(NULOUT,'(a)') 'Namelist RADIATION not found, using settings from NAERAD only'
-!      CASE DEFAULT
-!        CALL ABOR1('RADIATION_SETUP: error reading RADIATION section of namelist file')
-!    END SELECT
-
-! AI ATTENTION test
+
+! AI ATTENTION (parameters read in namelist file)
     file_name="namelist_ecrad"
     call rad_config%read(file_name=file_name)
-
-    ! Print configuration
-!    IF (IVERBOSESETUP > 1) THEN
-!      WRITE(NULOUT,'(a)') 'Radiation scheme settings:'
-!      CALL rad_config%print(IVERBOSE=IVERBOSESETUP)
-!    ENDIF
 
     ! Use configuration data to set-up radiation scheme, including
@@ -409,10 +278,5 @@
     ! results...
     ! Note that NMPSRTM(:)=(/  6, 6, 5, 5, 5, 5, 5, 4, 4, 3, 2, 2, 1, 6 /)
-! AI
-!!    NMPSRTM(:)=(/ 6, 6, 5, 5, 5, 5, 5, 4, 4, 3, 2, 2, 1, 6 /)
-!!    rad_config%i_albedo_from_band_sw = NMPSRTM
-!    call rad_config%define_sw_albedo_intervals(6, &
-!             &  (/ 0.25e-6_jprb, 0.44e-6_jprb, 1.19e-6_jprb, &
-!             &     2.38e-6_jprb, 4.00e-6_jprb /),  (/ 1,2,3,4,5,6 /))
+! AI (6 albedo SW bands) 
     call rad_config%define_sw_albedo_intervals(6, &
        &  [0.25e-6_jprb, 0.44e-6_jprb, 0.69e-6_jprb, &
@@ -422,5 +286,5 @@
     ! outside and inside the window region of the spectrum
 !     rad_config%i_emiss_from_band_lw = (/ 1,1,1,1,1,2,2,2,1,1,1,1,1,1,1,1 /)
-! AI
+! AI ATTENTION ?????
 !!    call rad_config%define_lw_emiss_intervals(3, &
 !!         &  (/ 8.0e-6_jprb,13.0e-6_jprb /),  (/ 1,2,1 /))
@@ -432,4 +296,20 @@
          &  NWEIGHT_PAR, IBAND_PAR, WEIGHT_PAR, &
          &  'photosynthetically active radiation, PAR')
+
+     rad_config%i_aerosol_type_map(1:13) = (/ &
+           &  -1, &  ! Sea salt, size bin 1 (OPAC)
+           &  -2, &  ! Sea salt, size bin 2 (OPAC)
+           &  -3, &  ! Sea salt, size bin 3 (OPAC)
+           &  -4, &  ! Hydrophilic organic matter (OPAC)
+           &  -5, &  ! Ammonium sulphate (OPAC)
+           &  -6, &
+           &  -7, &
+           &   1, &
+           &   2, &
+           &   3, &
+           &  -8, &
+           &  -9, &
+           &   4 /)  ! Stratospheric sulphate (hand edited from OPAC)
+   rad_config%aerosol_optics_override_file_name = 'aerosol_optics_lmdz.nc'
 
 !    IF (YRERAD%NAERMACC > 0) THEN
